<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use DateTime;
use Symfony\Component\Security\Core\User\UserInterface;
use JMS\Serializer\Annotation as Serializer;

/**
 * Answer
 *
 * @ORM\Table(name="answer");
 * @ORM\Entity(repositoryClass="App\Repository\AnswerRepository");
 * @ORM\HasLifecycleCallbacks()
 */
class Answer
{
    /**
     * @ORM\Column(name="id", type="integer") 
     * @ORM\Id()
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

   /**
     * @ORM\ManyToOne(targetEntity="App\Entity\Principle", inversedBy="answers")
     * @ORM\JoinColumn(name="principle_id", referencedColumnName="id")
     */
    protected $principle;

    /**
     * @ORM\Column(name="description", type="string", length=150)
     */
    protected $description;

    /**
     * @ORM\Column(name="selected", type="string", length=150)
     */
    protected $selected;
     
    /**
     * @var string
     *
     * @ORM\Column(name="content", type="text", nullable=true)
     */
    private $content;

    /**
     * @var int
     *
     * @ORM\Column(name="position", type="integer")
     */
    private $position;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getSelected(): ?string
    {
        return $this->selected;
    }

    public function setSelected(string $selected): self
    {
        $this->selected = $selected;

        return $this;
    }

    public function getContent(): ?string
    {
        return $this->content;
    }

    public function setContent(?string $content): self
    {
        $this->content = $content;

        return $this;
    }

    public function getPosition(): ?int
    {
        return $this->position;
    }

    public function setPosition(int $position): self
    {
        $this->position = $position;

        return $this;
    }

    public function getAnswer(): ?Principle
    {
        return $this->answer;
    }

    public function setAnswer(?Principle $answer): self
    {
        $this->answer = $answer;

        return $this;
    }

    public function getPrinciple(): ?Principle
    {
        return $this->principle;
    }

    public function setPrinciple(?Principle $principle): self
    {
        $this->principle = $principle;

        return $this;
    }

    
  
    
}