<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;
use DateTime;
use Symfony\Component\Security\Core\User\UserInterface;
use JMS\Serializer\Annotation as Serializer;
use JMS\Serializer\Annotation\Groups;
use JMS\Serializer\Annotation\MaxDepth;


/**
 * GrantMember
 *
 * @ORM\Table(name="grant_member")
 * @ORM\Entity(repositoryClass="App\Repository\GrantMemberRepository")
 * @ORM\HasLifecycleCallbacks()
 */
class GrantMember
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="is_ambassador", type="string", nullable=true, length=255, options={"default":"false"})
     * @Groups({"student_list"})
     */
    private $isambassador;


    /**
     * @ORM\OneToOne(targetEntity="App\Entity\User", inversedBy="grantmember")
     * @ORM\JoinColumn(name="student_id", referencedColumnName="id", onDelete="CASCADE")
     * @Groups({"student_list"})
     * @MaxDepth(5)
     */
    private $member; 

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\GrantAmbassador", inversedBy="grantmember")
     * @ORM\JoinColumn(name="grant_ambassador_id", referencedColumnName="id", onDelete="CASCADE")
     * @Groups({"student_list"})
     * @MaxDepth(4)
     */
    private $grantambassador;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getMember(): ?User
    {
        return $this->member;
    }

    public function setMember(?User $member): self
    {
        $this->member = $member;

        return $this;
    }

    public function getGrantambassador(): ?GrantAmbassador
    {
        return $this->grantambassador;
    }

    public function setGrantambassador(?GrantAmbassador $grantambassador): self
    {
        $this->grantambassador = $grantambassador;

        return $this;
    }

    public function getIsambassador(): ?string
    {
        return $this->isambassador;
    }

    public function setIsambassador(?string $isambassador): self
    {
        $this->isambassador = $isambassador;

        return $this;
    }

  

    
}
