<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use DateTime;
use Symfony\Component\Security\Core\User\UserInterface;
use JMS\Serializer\Annotation as Serializer;
use JMS\Serializer\Annotation\Groups;
use JMS\Serializer\Annotation\MaxDepth;

/**
 * GrantRequirement
 *
 * @ORM\Table(name="`grant_requirement`")
 * @ORM\Entity(repositoryClass="App\Repository\GrantRequirementRepository")
 * @ORM\HasLifecycleCallbacks()
 */
class GrantRequirement
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;    

    /**
     * @ORM\Column(name="active_time", type="integer", options={"default":"0"}) 
     */
    protected $activeTime;

    /**
     * @ORM\Column(name="receipt_time", type="integer", options={"default":"0"}) 
     */
    protected $receiptTime;

    /**
     * @ORM\Column(name="mbs_graduates", type="integer", options={"default":"0"}) 
     */
    protected $mbsGraduates;

    /**
     * @ORM\Column(name="sa_graduates", type="integer", options={"default":"0"}) 
     */
    protected $saGraduates;

    /**
     * @ORM\Column(name="nsa_graduates", type="integer", options={"default":"0"}) 
     */
    protected $nsaGraduates;

    /**
     * @var string
     *
     * @ORM\Column(name="country", type="string", length=255, nullable=true)
     */
    private $country;

    /**
     * @var string
     *
     * @ORM\Column(name="language", type="string", length=255, nullable=true)
     */
    private $language;

     /**
     * @var string
     *
     * @ORM\Column(name="type", type="string", length=255)
     */
    private $type;

    /**
     * @var string
     *
     * @ORM\Column(name="customized", type="string", length=255, options={"default":"false"})
     */
    private $customized;
    
    /**
     * @ORM\Column(name="created_at", type="datetime")
     * @Groups({"grant_ambassador_list"})
     */
    protected $createdAt;

    /**
     * @ORM\Column(name="updated_at", type="datetime")
     * @Groups({"grant_ambassador_list"})
     */
    protected $updatedAt;

    public function __construct()
    {
        $this->grantupdates = new ArrayCollection();
        $this->grantsambassador = new ArrayCollection();
    }


    public function __toString(){
            return $this->name;
    }

   
    /**
     * @param mixed $updatedAt
     * @return self
     */
    public function setUpdatedAt($updatedAt)
    {
        $this->updatedAt = $updatedAt;

        return $this;
    }

    /**
     * @ORM\PrePersist
     * @ORM\PreUpdate
     */
    public function updatedTimestamps()
    {
        $dateTimeNow = new DateTime('now');
        $this->setUpdatedAt($dateTimeNow);
        if ($this->getCreatedAt() === null) {
            $this->setCreatedAt($dateTimeNow);
        }
    }

    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->createdAt;
    }

    public function setCreatedAt(\DateTimeInterface $createdAt): self
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    public function getUpdatedAt(): ?\DateTimeInterface
    {
        return $this->updatedAt;
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getActiveTime(): ?int
    {
        return $this->activeTime;
    }

    public function setActiveTime(int $activeTime): self
    {
        $this->activeTime = $activeTime;

        return $this;
    }

    public function getReceiptTime(): ?int
    {
        return $this->receiptTime;
    }

    public function setReceiptTime(int $receiptTime): self
    {
        $this->receiptTime = $receiptTime;

        return $this;
    }

    public function getMbsGraduates(): ?int
    {
        return $this->mbsGraduates;
    }

    public function setMbsGraduates(int $mbsGraduates): self
    {
        $this->mbsGraduates = $mbsGraduates;

        return $this;
    }

    public function getSaGraduates(): ?int
    {
        return $this->saGraduates;
    }

    public function setSaGraduates(int $saGraduates): self
    {
        $this->saGraduates = $saGraduates;

        return $this;
    }

    public function getNsaGraduates(): ?int
    {
        return $this->nsaGraduates;
    }

    public function setNsaGraduates(int $nsaGraduates): self
    {
        $this->nsaGraduates = $nsaGraduates;

        return $this;
    }

    public function getCountry(): ?string
    {
        return $this->country;
    }

    public function setCountry(?string $country): self
    {
        $this->country = $country;

        return $this;
    }

    public function getLanguage(): ?string
    {
        return $this->language;
    }

    public function setLanguage(?string $language): self
    {
        $this->language = $language;

        return $this;
    }

    public function getType(): ?string
    {
        return $this->type;
    }

    public function setType(string $type): self
    {
        $this->type = $type;

        return $this;
    }

    public function getCustomized(): ?string
    {
        return $this->customized;
    }

    public function setCustomized(string $customized): self
    {
        $this->customized = $customized;

        return $this;
    }

    

  
}