<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;
use DateTime;
use Symfony\Component\Security\Core\User\UserInterface;
use JMS\Serializer\Annotation as Serializer;
use JMS\Serializer\Annotation\Groups;


/**
 * Introduction
 *
 * @ORM\Table(name="introduction")
 * @ORM\Entity(repositoryClass="App\Repository\IntroductionRepository")
 * @ORM\HasLifecycleCallbacks()
 */
class Introduction
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     * @Groups({"group_list"})
     */
    private $id;

    /**
     * @ORM\Column(name="type", type="string", length=150)
     * @Groups({"group_list"})
     */
    protected $type;

    /**
     * @ORM\Column(name="language", type="string", length=150)
     */
    protected $language;

    /**
     * @var string
     *
     * @ORM\Column(name="content", type="text", nullable=true)
     */
    private $content; 

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\Groupe", inversedBy="introduction")
     * @ORM\JoinColumn(name="groupe_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $group;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getType(): ?string
    {
        return $this->type;
    }

    public function setType(string $type): self
    {
        $this->type = $type;

        return $this;
    }

    public function getContent(): ?string
    {
        return $this->content;
    }

    public function setContent(?string $content): self
    {
        $this->content = $content;

        return $this;
    }

    public function getGroup(): ?Groupe
    {
        return $this->group;
    }

    public function setGroup(?Groupe $group): self
    {
        $this->group = $group;

        return $this;
    }

    public function getLanguage(): ?string
    {
        return $this->language;
    }

    public function setLanguage(string $language): self
    {
        $this->language = $language;

        return $this;
    }

   
    
}
