<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;
use DateTime;
use Symfony\Component\Security\Core\User\UserInterface;
use JMS\Serializer\Annotation as Serializer;
use JMS\Serializer\Annotation\Groups;


/**
 * PilotGroup
 *
 * @ORM\Table(name="pilot_group")
 * @ORM\Entity(repositoryClass="App\Repository\PilotGroupRepository")
 * @ORM\HasLifecycleCallbacks()
 */
class PilotGroup
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     * @Groups({"group_list"})
     */
    private $id;


    /**
     * @ORM\OneToOne(targetEntity="App\Entity\User", inversedBy="pilotgroup")
     * @ORM\JoinColumn(name="pilot_id", referencedColumnName="id", onDelete="CASCADE")
     */
    private $ambassador; 

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\Groupe", inversedBy="pilotgroup")
     * @ORM\JoinColumn(name="groupe_id", referencedColumnName="id", onDelete="CASCADE")
     * @Groups({"group_list"})
     */
    private $group;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getAmbassador(): ?User
    {
        return $this->ambassador;
    }

    public function setAmbassador(?User $ambassador): self
    {
        $this->ambassador = $ambassador;

        return $this;
    }

    public function getGroup(): ?Groupe
    {
        return $this->group;
    }

    public function setGroup(?Groupe $group): self
    {
        $this->group = $group;

        return $this;
    }

    
    
}
