<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Symfony\Component\Security\Core\User\UserInterface;
use JMS\Serializer\Annotation as Serializer;
use JMS\Serializer\Annotation\Groups;
use Doctrine\ORM\Mapping as ORM;
use DateTime;

/**
 * @ORM\Table(name="program_jr")
 * @ORM\Entity(repositoryClass="App\Repository\ProgramJrRepository")
 * @ORM\HasLifecycleCallbacks()
 */
class ProgramJr
{
    /**
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     * @Groups({"student_list", "future_ambassador", "student_group"})
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="plan1", type="text", nullable=true)
     */
    private $plan1;

    /**
     * @var string
     *
     * @ORM\Column(name="plan2", type="text", nullable=true)
     */
    private $plan2;

    /**
     * @var string
     *
     * @ORM\Column(name="product1", type="text", nullable=true)
     */
    private $product1;

    /**
     * @var string
     *
     * @ORM\Column(name="product2", type="text", nullable=true)
     */
    private $product2;

    /**
     * @var string
     *
     * @ORM\Column(name="product3", type="text", nullable=true)
     */
    private $product3;

    /**
     * @var string
     *
     * @ORM\Column(name="product4", type="text", nullable=true)
     */
    private $product4;

    /**
     * @var string
     *
     * @ORM\Column(name="product5", type="text", nullable=true)
     */
    private $product5;

    /**
     * @var string
     *
     * @ORM\Column(name="product6", type="text", nullable=true)
     */
    private $product6;

    /**
     * @var string
     *
     * @ORM\Column(name="product7", type="text", nullable=true)
     */
    private $product7;

    /**
     * @var string
     *
     * @ORM\Column(name="process1", type="json_array")
     */
    private $process1;

    /**
     * @var string
     *
     * @ORM\Column(name="process2", type="text", nullable=true)
     */
    private $process2;

    /**
     * @var string
     *
     * @ORM\Column(name="process3", type="text", nullable=true)
     */
    private $process3;

    /**
     * @var string
     *
     * @ORM\Column(name="process4", type="text", nullable=true)
     */
    private $process4;

    /**
     * @var string
     *
     * @ORM\Column(name="price1", type="text", nullable=true)
     */
    private $price1;

    /**
     * @var string
     *
     * @ORM\Column(name="price2", type="text", nullable=true)
     */
    private $price2;

    /**
     * @var string
     *
     * @ORM\Column(name="price3", type="text", nullable=true)
     */
    private $price3;

    /**
     * @var string
     *
     * @ORM\Column(name="price4", type="text", nullable=true)
     */
    private $price4;

    /**
     * @var string
     *
     * @ORM\Column(name="promotion1", type="text", nullable=true)
     */
    private $promotion1;

    /**
     * @var string
     *
     * @ORM\Column(name="promotion2", type="text", nullable=true)
     */
    private $promotion2;

    /**
     * @var string
     *
     * @ORM\Column(name="promotion3", type="text", nullable=true)
     */
    private $promotion3;

    /**
     * @var string
     *
     * @ORM\Column(name="promotion4", type="text", nullable=true)
     */
    private $promotion4;

    /**
     * @var string
     *
     * @ORM\Column(name="promotion5", type="text", nullable=true)
     */
    private $promotion5;

    /**
     * @var string
     *
     * @ORM\Column(name="paperwork1", type="text", nullable=true)
     */
    private $paperwork1;

    /**
     * @var string
     *
     * @ORM\Column(name="paperwork2", type="text", nullable=true, length=255)
     */
    private $paperwork2;

    /**
     * @var string
     *
     * @ORM\Column(name="paperwork3", type="json_array")
     */
    private $paperwork3;

    /**
     * @var string
     *
     * @ORM\Column(name="paperwork4", type="json_array")
     */
    private $paperwork4 = array();

    /**
     * @var string
     *
     * @ORM\Column(name="paperwork5", type="json_array")
     */
    private $paperwork5 = array();

    /**
     * @var string
     *
     * @ORM\Column(name="paperwork6", type="json_array")
     */
    private $paperwork6 = array();

    /**
     * @var string
     *
     * @ORM\Column(name="paperwork7", type="json_array")
     */
    private $paperwork7 = array();

    /**
     * @var string
     *
     * @ORM\Column(name="paperwork8", type="json_array")
     */
    private $paperwork8 = array();


    /**
     * @var string
     *
     * @ORM\Column(name="qualityp1", type="string", nullable=true, length=255)
     */
    private $qualityP1;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityp2", type="string", nullable=true, length=255)
     */
    private $qualityP2;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityp3", type="string", nullable=true, length=255)
     */
    private $qualityP3;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityp4", type="string", nullable=true, length=255)
     */
    private $qualityP4;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityp5", type="string", nullable=true, length=255)
     */
    private $qualityP5;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityp6", type="string", nullable=true, length=255)
     */
    private $qualityP6;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityp7", type="string", nullable=true, length=255)
     */
    private $qualityP7;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityp8", type="string", nullable=true, length=255)
     */
    private $qualityP8;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityq1", type="string", nullable=true, length=255)
     */
    private $qualityQ1;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityq2", type="string", nullable=true, length=255)
     */
    private $qualityQ2;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityq3", type="string", nullable=true, length=255)
     */
    private $qualityQ3;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityq4", type="string", nullable=true, length=255)
     */
    private $qualityQ4;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityq5", type="string", nullable=true, length=255)
     */
    private $qualityQ5;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityq6", type="string", nullable=true, length=255)
     */
    private $qualityQ6;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityq7", type="string", nullable=true, length=255)
     */
    private $qualityQ7;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityq8", type="string", nullable=true, length=255)
     */
    private $qualityQ8;


    /**
     * @var string
     *
     * @ORM\Column(name="qualityg1", type="text", nullable=true)
     */
    private $qualityG1;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityg2", type="text", nullable=true)
     */
    private $qualityG2;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityg3", type="text", nullable=true)
     */
    private $qualityG3;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityg4", type="text", nullable=true)
     */
    private $qualityG4;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityg5", type="text", nullable=true)
     */
    private $qualityG5;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityg6", type="text", nullable=true)
     */
    private $qualityG6;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityg7", type="text", nullable=true)
     */
    private $qualityG7;

    /**
     * @var string
     *
     * @ORM\Column(name="qualityg8", type="text", nullable=true)
     */
    private $qualityg8;

    /**
     * @var string
     *
     * @ORM\Column(name="service1", type="text", nullable=true)
     */
    private $service1;

    /**
     * @var string
     *
     * @ORM\Column(name="service2", type="text", nullable=true)
     */
    private $service2;

    /**
     * @var string
     *
     * @ORM\Column(name="service3", type="text", nullable=true)
     */
    private $service3;

    /**
     * @var string
     *
     * @ORM\Column(name="service4", type="text", nullable=true)
     */
    private $service4;

    /**
     * @var string
     *
     * @ORM\Column(name="service5", type="text", nullable=true)
     */
    private $service5;

    /**
     * @var string
     *
     * @ORM\Column(name="service6", type="string", nullable=true, length=255)
     */
    private $service6;

    /**
     * @var string
     *
     * @ORM\Column(name="history1", type="text", nullable=true)
     */
    private $history1;

    /**
     * @var string
     *
     * @ORM\Column(name="history2", type="string", nullable=true, length=255)
     */
    private $history2;

    /**
     * @var string
     *
     * @ORM\Column(name="history3", type="string", nullable=true, length=255)
     */
    private $history3;

    /**
     * @var string
     *
     * @ORM\Column(name="state", type="string", nullable=true, length=255)
     * @Groups({"student_list", "student_group"})
     */
    private $state;

    /**
     * @var string
     *
     * @ORM\Column(name="revisionplan", type="text", nullable=true)
     */
    private $revisionplan;

    /**
     * @var string
     *
     * @ORM\Column(name="revisionproduct", type="text", nullable=true)
     */
    private $revisionproduct;

    /**
     * @var string
     *
     * @ORM\Column(name="revisionprocess", type="text", nullable=true)
     */
    private $revisionprocess;

    /**
     * @var string
     *
     * @ORM\Column(name="revisionpromotion", type="text", nullable=true)
     */
    private $revisionpromotion;

    /**
     * @var string
     *
     * @ORM\Column(name="revisionprice", type="text", nullable=true)
     */
    private $revisionprice;

    /**
     * @var string
     *
     * @ORM\Column(name="revisionpaperwork", type="text", nullable=true)
     */
    private $revisionpaperwork;

    /**
     * @var string
     *
     * @ORM\Column(name="revisionquality", type="text", nullable=true)
     */
    private $revisionquality;

    /**
     * @var string
     *
     * @ORM\Column(name="revisionservice", type="text", nullable=true)
     */
    private $revisionservice;

    /**
     * @var string
     *
     * @ORM\Column(name="statusplan", type="string", nullable=true, length=255)
     */
    private $statusplan;

    /**
     * @var string
     *
     * @ORM\Column(name="statusproduct", type="string", nullable=true, length=255)
     */
    private $statusproduct;

    /**
     * @var string
     *
     * @ORM\Column(name="statusprice", type="string", nullable=true, length=255)
     */
    private $statusprice;

    /**
     * @var string
     *
     * @ORM\Column(name="statuspromotion", type="string", nullable=true, length=255)
     */
    private $statuspromotion;

    /**
     * @var string
     *
     * @ORM\Column(name="statuspaperwork", type="string", nullable=true, length=255)
     */
    private $statuspaperwork;

    /**
     * @var string
     *
     * @ORM\Column(name="statusprocess", type="string", nullable=true, length=255)
     */
    private $statusprocess;

    /**
     * @var string
     *
     * @ORM\Column(name="statusquality", type="string", nullable=true, length=255)
     */
    private $statusquality;

    /**
     * @var string
     *
     * @ORM\Column(name="statusservice", type="string", nullable=true, length=255)
     */
    private $statusservice;

    /**
     * @var string
     *
     * @ORM\Column(name="filestudent", type="string", nullable=true, length=255)
     * @Groups({"student_list", "future_ambassador", "student_group"})
     */
    private $filestudent;

    /**
     * @var string
     *
     * @ORM\Column(name="fileambassador", type="string", nullable=true, length=255)
     */
    private $fileambassador;

    /**
     * @var string
     *
     * @ORM\Column(name="modality", type="string", nullable=true, length=255)
     * @Groups({"student_list", "future_ambassador", "student_group"}) 
     * 
     */
    private $modality;

    /**
     * @var string
     *
     * @ORM\Column(name="code", type="string", nullable=true, length=255)
     */
    private $code;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="student_file_upload_date", nullable=true, type="datetime")
     */
    private $uploadDateStudent;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="admin_file_upload_date", nullable=true, type="datetime")
     */
    private $uploadDateAdmin;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="approval_date", nullable=true, type="date")
     */
    private $approvalDate;

    /**
     * @var string
     *
     * @ORM\Column(name="authorization_code", type="string", nullable=true, length=255)
     */
    private $authorizationCode;

    /**
     * @var string
     *
     * @ORM\Column(name="attendance_code", type="string", nullable=true, length=255)
     */
    private $attendanceCode;



    /**
     * @ORM\OneToOne(targetEntity="App\Entity\User", inversedBy="programjr")
     * @ORM\JoinColumn(name="student_id", referencedColumnName="id", onDelete="CASCADE")
     * @Groups({"student_list"})
     */
    private $student;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getPlan1(): ?string
    {
        return $this->plan1;
    }

    public function setPlan1(?string $plan1): self
    {
        $this->plan1 = $plan1;

        return $this;
    }

    public function getPlan2(): ?string
    {
        return $this->plan2;
    }

    public function setPlan2(?string $plan2): self
    {
        $this->plan2 = $plan2;

        return $this;
    }

    public function getProduct1(): ?string
    {
        return $this->product1;
    }

    public function setProduct1(?string $product1): self
    {
        $this->product1 = $product1;

        return $this;
    }

    public function getProduct2(): ?string
    {
        return $this->product2;
    }

    public function setProduct2(?string $product2): self
    {
        $this->product2 = $product2;

        return $this;
    }

    public function getProduct3(): ?string
    {
        return $this->product3;
    }

    public function setProduct3(?string $product3): self
    {
        $this->product3 = $product3;

        return $this;
    }

    public function getProduct4(): ?string
    {
        return $this->product4;
    }

    public function setProduct4(?string $product4): self
    {
        $this->product4 = $product4;

        return $this;
    }

    public function getProduct5(): ?string
    {
        return $this->product5;
    }

    public function setProduct5(?string $product5): self
    {
        $this->product5 = $product5;

        return $this;
    }

    public function getProduct6(): ?string
    {
        return $this->product6;
    }

    public function setProduct6(?string $product6): self
    {
        $this->product6 = $product6;

        return $this;
    }

    public function getProduct7(): ?string
    {
        return $this->product7;
    }

    public function setProduct7(?string $product7): self
    {
        $this->product7 = $product7;

        return $this;
    }

    public function getProcess1(): ?array
    {
        return $this->process1;
    }

    public function setProcess1(array $process1): self
    {
        $this->process1 = $process1;

        return $this;
    }

    public function getProcess2(): ?string
    {
        return $this->process2;
    }

    public function setProcess2(?string $process2): self
    {
        $this->process2 = $process2;

        return $this;
    }

    public function getProcess3(): ?string
    {
        return $this->process3;
    }

    public function setProcess3(?string $process3): self
    {
        $this->process3 = $process3;

        return $this;
    }

    public function getProcess4(): ?string
    {
        return $this->process4;
    }

    public function setProcess4(?string $process4): self
    {
        $this->process4 = $process4;

        return $this;
    }

    public function getPrice1(): ?string
    {
        return $this->price1;
    }

    public function setPrice1(?string $price1): self
    {
        $this->price1 = $price1;

        return $this;
    }

    public function getPrice2(): ?string
    {
        return $this->price2;
    }

    public function setPrice2(?string $price2): self
    {
        $this->price2 = $price2;

        return $this;
    }

    public function getPrice3(): ?string
    {
        return $this->price3;
    }

    public function setPrice3(?string $price3): self
    {
        $this->price3 = $price3;

        return $this;
    }

    public function getPrice4(): ?string
    {
        return $this->price4;
    }

    public function setPrice4(?string $price4): self
    {
        $this->price4 = $price4;

        return $this;
    }

    public function getPromotion1(): ?string
    {
        return $this->promotion1;
    }

    public function setPromotion1(?string $promotion1): self
    {
        $this->promotion1 = $promotion1;

        return $this;
    }

    public function getPromotion2(): ?string
    {
        return $this->promotion2;
    }

    public function setPromotion2(?string $promotion2): self
    {
        $this->promotion2 = $promotion2;

        return $this;
    }

    public function getPromotion3(): ?string
    {
        return $this->promotion3;
    }

    public function setPromotion3(?string $promotion3): self
    {
        $this->promotion3 = $promotion3;

        return $this;
    }

    public function getPromotion4(): ?string
    {
        return $this->promotion4;
    }

    public function setPromotion4(?string $promotion4): self
    {
        $this->promotion4 = $promotion4;

        return $this;
    }

    public function getPromotion5(): ?string
    {
        return $this->promotion5;
    }

    public function setPromotion5(?string $promotion5): self
    {
        $this->promotion5 = $promotion5;

        return $this;
    }

    public function getPaperwork1(): ?string
    {
        return $this->paperwork1;
    }

    public function setPaperwork1(?string $paperwork1): self
    {
        $this->paperwork1 = $paperwork1;

        return $this;
    }

    public function getPaperwork2(): ?string
    {
        return $this->paperwork2;
    }

    public function setPaperwork2(?string $paperwork2): self
    {
        $this->paperwork2 = $paperwork2;

        return $this;
    }

    public function getPaperwork3(): ?array
    {
        return $this->paperwork3;
    }

    public function setPaperwork3(array $paperwork3): self
    {
        $this->paperwork3 = $paperwork3;

        return $this;
    }

    public function getPaperwork4(): ?array
    {
        return $this->paperwork4;
    }

    public function setPaperwork4(array $paperwork4): self
    {
        $this->paperwork4 = $paperwork4;

        return $this;
    }

    public function getPaperwork5(): ?array
    {
        return $this->paperwork5;
    }

    public function setPaperwork5(array $paperwork5): self
    {
        $this->paperwork5 = $paperwork5;

        return $this;
    }

    public function getPaperwork6(): ?array
    {
        return $this->paperwork6;
    }

    public function setPaperwork6(array $paperwork6): self
    {
        $this->paperwork6 = $paperwork6;

        return $this;
    }

    public function getPaperwork7(): ?array
    {
        return $this->paperwork7;
    }

    public function setPaperwork7(array $paperwork7): self
    {
        $this->paperwork7 = $paperwork7;

        return $this;
    }

    public function getPaperwork8(): ?array
    {
        return $this->paperwork8;
    }

    public function setPaperwork8(array $paperwork8): self
    {
        $this->paperwork8 = $paperwork8;

        return $this;
    }

    public function getQualityP1(): ?string
    {
        return $this->qualityP1;
    }

    public function setQualityP1(?string $qualityP1): self
    {
        $this->qualityP1 = $qualityP1;

        return $this;
    }

    public function getQualityP2(): ?string
    {
        return $this->qualityP2;
    }

    public function setQualityP2(?string $qualityP2): self
    {
        $this->qualityP2 = $qualityP2;

        return $this;
    }

    public function getQualityP3(): ?string
    {
        return $this->qualityP3;
    }

    public function setQualityP3(?string $qualityP3): self
    {
        $this->qualityP3 = $qualityP3;

        return $this;
    }

    public function getQualityP4(): ?string
    {
        return $this->qualityP4;
    }

    public function setQualityP4(?string $qualityP4): self
    {
        $this->qualityP4 = $qualityP4;

        return $this;
    }

    public function getQualityP5(): ?string
    {
        return $this->qualityP5;
    }

    public function setQualityP5(?string $qualityP5): self
    {
        $this->qualityP5 = $qualityP5;

        return $this;
    }

    public function getQualityP6(): ?string
    {
        return $this->qualityP6;
    }

    public function setQualityP6(?string $qualityP6): self
    {
        $this->qualityP6 = $qualityP6;

        return $this;
    }

    public function getQualityP7(): ?string
    {
        return $this->qualityP7;
    }

    public function setQualityP7(?string $qualityP7): self
    {
        $this->qualityP7 = $qualityP7;

        return $this;
    }

    public function getQualityP8(): ?string
    {
        return $this->qualityP8;
    }

    public function setQualityP8(?string $qualityP8): self
    {
        $this->qualityP8 = $qualityP8;

        return $this;
    }

    public function getQualityQ1(): ?string
    {
        return $this->qualityQ1;
    }

    public function setQualityQ1(?string $qualityQ1): self
    {
        $this->qualityQ1 = $qualityQ1;

        return $this;
    }

    public function getQualityQ2(): ?string
    {
        return $this->qualityQ2;
    }

    public function setQualityQ2(?string $qualityQ2): self
    {
        $this->qualityQ2 = $qualityQ2;

        return $this;
    }

    public function getQualityQ3(): ?string
    {
        return $this->qualityQ3;
    }

    public function setQualityQ3(?string $qualityQ3): self
    {
        $this->qualityQ3 = $qualityQ3;

        return $this;
    }

    public function getQualityQ4(): ?string
    {
        return $this->qualityQ4;
    }

    public function setQualityQ4(?string $qualityQ4): self
    {
        $this->qualityQ4 = $qualityQ4;

        return $this;
    }

    public function getQualityQ5(): ?string
    {
        return $this->qualityQ5;
    }

    public function setQualityQ5(?string $qualityQ5): self
    {
        $this->qualityQ5 = $qualityQ5;

        return $this;
    }

    public function getQualityQ6(): ?string
    {
        return $this->qualityQ6;
    }

    public function setQualityQ6(?string $qualityQ6): self
    {
        $this->qualityQ6 = $qualityQ6;

        return $this;
    }

    public function getQualityQ7(): ?string
    {
        return $this->qualityQ7;
    }

    public function setQualityQ7(?string $qualityQ7): self
    {
        $this->qualityQ7 = $qualityQ7;

        return $this;
    }

    public function getQualityQ8(): ?string
    {
        return $this->qualityQ8;
    }

    public function setQualityQ8(?string $qualityQ8): self
    {
        $this->qualityQ8 = $qualityQ8;

        return $this;
    }

    public function getQualityG1(): ?string
    {
        return $this->qualityG1;
    }

    public function setQualityG1(?string $qualityG1): self
    {
        $this->qualityG1 = $qualityG1;

        return $this;
    }

    public function getQualityG2(): ?string
    {
        return $this->qualityG2;
    }

    public function setQualityG2(?string $qualityG2): self
    {
        $this->qualityG2 = $qualityG2;

        return $this;
    }

    public function getQualityG3(): ?string
    {
        return $this->qualityG3;
    }

    public function setQualityG3(?string $qualityG3): self
    {
        $this->qualityG3 = $qualityG3;

        return $this;
    }

    public function getQualityG4(): ?string
    {
        return $this->qualityG4;
    }

    public function setQualityG4(?string $qualityG4): self
    {
        $this->qualityG4 = $qualityG4;

        return $this;
    }

    public function getQualityG5(): ?string
    {
        return $this->qualityG5;
    }

    public function setQualityG5(?string $qualityG5): self
    {
        $this->qualityG5 = $qualityG5;

        return $this;
    }

    public function getQualityG6(): ?string
    {
        return $this->qualityG6;
    }

    public function setQualityG6(?string $qualityG6): self
    {
        $this->qualityG6 = $qualityG6;

        return $this;
    }

    public function getQualityG7(): ?string
    {
        return $this->qualityG7;
    }

    public function setQualityG7(?string $qualityG7): self
    {
        $this->qualityG7 = $qualityG7;

        return $this;
    }

    public function getQualityg8(): ?string
    {
        return $this->qualityg8;
    }

    public function setQualityg8(?string $qualityg8): self
    {
        $this->qualityg8 = $qualityg8;

        return $this;
    }

    public function getService1(): ?string
    {
        return $this->service1;
    }

    public function setService1(?string $service1): self
    {
        $this->service1 = $service1;

        return $this;
    }

    public function getService2(): ?string
    {
        return $this->service2;
    }

    public function setService2(?string $service2): self
    {
        $this->service2 = $service2;

        return $this;
    }

    public function getService3(): ?string
    {
        return $this->service3;
    }

    public function setService3(?string $service3): self
    {
        $this->service3 = $service3;

        return $this;
    }

    public function getService4(): ?string
    {
        return $this->service4;
    }

    public function setService4(?string $service4): self
    {
        $this->service4 = $service4;

        return $this;
    }

    public function getService5(): ?string
    {
        return $this->service5;
    }

    public function setService5(?string $service5): self
    {
        $this->service5 = $service5;

        return $this;
    }

    public function getService6(): ?string
    {
        return $this->service6;
    }

    public function setService6(?string $service6): self
    {
        $this->service6 = $service6;

        return $this;
    }

    public function getHistory1(): ?string
    {
        return $this->history1;
    }

    public function setHistory1(?string $history1): self
    {
        $this->history1 = $history1;

        return $this;
    }

    public function getHistory2(): ?string
    {
        return $this->history2;
    }

    public function setHistory2(?string $history2): self
    {
        $this->history2 = $history2;

        return $this;
    }

    public function getHistory3(): ?string
    {
        return $this->history3;
    }

    public function setHistory3(?string $history3): self
    {
        $this->history3 = $history3;

        return $this;
    }

    public function getState(): ?string
    {
        return $this->state;
    }

    public function setState(?string $state): self
    {
        $this->state = $state;

        return $this;
    }

    public function getRevisionplan(): ?string
    {
        return $this->revisionplan;
    }

    public function setRevisionplan(?string $revisionplan): self
    {
        $this->revisionplan = $revisionplan;

        return $this;
    }

    public function getRevisionproduct(): ?string
    {
        return $this->revisionproduct;
    }

    public function setRevisionproduct(?string $revisionproduct): self
    {
        $this->revisionproduct = $revisionproduct;

        return $this;
    }

    public function getRevisionprocess(): ?string
    {
        return $this->revisionprocess;
    }

    public function setRevisionprocess(?string $revisionprocess): self
    {
        $this->revisionprocess = $revisionprocess;

        return $this;
    }

    public function getRevisionpromotion(): ?string
    {
        return $this->revisionpromotion;
    }

    public function setRevisionpromotion(?string $revisionpromotion): self
    {
        $this->revisionpromotion = $revisionpromotion;

        return $this;
    }

    public function getRevisionprice(): ?string
    {
        return $this->revisionprice;
    }

    public function setRevisionprice(?string $revisionprice): self
    {
        $this->revisionprice = $revisionprice;

        return $this;
    }

    public function getRevisionpaperwork(): ?string
    {
        return $this->revisionpaperwork;
    }

    public function setRevisionpaperwork(?string $revisionpaperwork): self
    {
        $this->revisionpaperwork = $revisionpaperwork;

        return $this;
    }

    public function getRevisionquality(): ?string
    {
        return $this->revisionquality;
    }

    public function setRevisionquality(?string $revisionquality): self
    {
        $this->revisionquality = $revisionquality;

        return $this;
    }

    public function getRevisionservice(): ?string
    {
        return $this->revisionservice;
    }

    public function setRevisionservice(?string $revisionservice): self
    {
        $this->revisionservice = $revisionservice;

        return $this;
    }

    public function getStatusplan(): ?string
    {
        return $this->statusplan;
    }

    public function setStatusplan(?string $statusplan): self
    {
        $this->statusplan = $statusplan;

        return $this;
    }

    public function getStatusproduct(): ?string
    {
        return $this->statusproduct;
    }

    public function setStatusproduct(?string $statusproduct): self
    {
        $this->statusproduct = $statusproduct;

        return $this;
    }

    public function getStatusprice(): ?string
    {
        return $this->statusprice;
    }

    public function setStatusprice(?string $statusprice): self
    {
        $this->statusprice = $statusprice;

        return $this;
    }

    public function getStatuspromotion(): ?string
    {
        return $this->statuspromotion;
    }

    public function setStatuspromotion(?string $statuspromotion): self
    {
        $this->statuspromotion = $statuspromotion;

        return $this;
    }

    public function getStatuspaperwork(): ?string
    {
        return $this->statuspaperwork;
    }

    public function setStatuspaperwork(?string $statuspaperwork): self
    {
        $this->statuspaperwork = $statuspaperwork;

        return $this;
    }

    public function getStatusprocess(): ?string
    {
        return $this->statusprocess;
    }

    public function setStatusprocess(?string $statusprocess): self
    {
        $this->statusprocess = $statusprocess;

        return $this;
    }

    public function getStatusquality(): ?string
    {
        return $this->statusquality;
    }

    public function setStatusquality(?string $statusquality): self
    {
        $this->statusquality = $statusquality;

        return $this;
    }

    public function getStatusservice(): ?string
    {
        return $this->statusservice;
    }

    public function setStatusservice(?string $statusservice): self
    {
        $this->statusservice = $statusservice;

        return $this;
    }

    public function getFilestudent(): ?string
    {
        return $this->filestudent;
    }

    public function setFilestudent(?string $filestudent): self
    {
        $this->filestudent = $filestudent;

        return $this;
    }

    public function getFileambassador(): ?string
    {
        return $this->fileambassador;
    }

    public function setFileambassador(?string $fileambassador): self
    {
        $this->fileambassador = $fileambassador;

        return $this;
    }

    public function getModality(): ?string
    {
        return $this->modality;
    }

    public function setModality(?string $modality): self
    {
        $this->modality = $modality;

        return $this;
    }

    public function getCode(): ?string
    {
        return $this->code;
    }

    public function setCode(?string $code): self
    {
        $this->code = $code;

        return $this;
    }

    public function getUploadDateStudent(): ?\DateTimeInterface
    {
        return $this->uploadDateStudent;
    }

    public function setUploadDateStudent(?\DateTimeInterface $uploadDateStudent): self
    {
        $this->uploadDateStudent = $uploadDateStudent;

        return $this;
    }

    public function getUploadDateAdmin(): ?\DateTimeInterface
    {
        return $this->uploadDateAdmin;
    }

    public function setUploadDateAdmin(?\DateTimeInterface $uploadDateAdmin): self
    {
        $this->uploadDateAdmin = $uploadDateAdmin;

        return $this;
    }

    public function getApprovalDate(): ?\DateTimeInterface
    {
        return $this->approvalDate;
    }

    public function setApprovalDate(?\DateTimeInterface $approvalDate): self
    {
        $this->approvalDate = $approvalDate;

        return $this;
    }

    public function getAuthorizationCode(): ?string
    {
        return $this->authorizationCode;
    }

    public function setAuthorizationCode(?string $authorizationCode): self
    {
        $this->authorizationCode = $authorizationCode;

        return $this;
    }

    public function getAttendanceCode(): ?string
    {
        return $this->attendanceCode;
    }

    public function setAttendanceCode(?string $attendanceCode): self
    {
        $this->attendanceCode = $attendanceCode;

        return $this;
    }

    public function getStudent(): ?User
    {
        return $this->student;
    }

    public function setStudent(?User $student): self
    {
        $this->student = $student;

        return $this;
    }
}
