<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use DateTime;
use Symfony\Component\Security\Core\User\UserInterface;
use JMS\Serializer\Annotation as Serializer;
use JMS\Serializer\Annotation\Groups;

/**
 * Resource
 *
 * @ORM\Table(name="resource")
 * @ORM\Entity(repositoryClass="App\Repository\ResourceRepository")
 * @ORM\HasLifecycleCallbacks() 
 */
class Resource
{
    /**
     * @var int
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\ResourceCategory", inversedBy="resources")
     * @ORM\JoinColumn(name="resource_category_id", referencedColumnName="id", onDelete="CASCADE")     
     * 
     */
    private $resourcecategory;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=255)
     */
    private $name;

    /**
     * @var string
     *
     * @ORM\Column(name="picture", type="string", length=255, nullable=true)
     */
    private $picture;

    /**
     * @var string
     *
     * @ORM\Column(name="description", type="text", nullable=true)
     */
    private $description;

    /**
     * @var string
     *
     * @ORM\Column(name="version", type="string", length=255)
     */
    private $version;

    /**
     * @var string
     *
     * @ORM\Column(name="pdffile", type="string", length=255, nullable=true)
     */
    private $pdffile;

    /**
     * @var string
     *
     * @ORM\Column(name="pngfile", type="string", length=255, nullable=true)
     */
    private $pngfile;

    /**
     * @var string
     *
     * @ORM\Column(name="pptfile", type="string", length=255, nullable=true)
     */
    private $pptfile;

    /**
     * @var string
     *
     * @ORM\Column(name="zipfile", type="string", length=255, nullable=true)
     */
    private $zipfile;

    /**
     * @var string
     *
     * @ORM\Column(name="videofile", type="string", length=255, nullable=true)
     */
    private $videofile;

    /**
     * @var string
     *
     * @ORM\Column(name="docxfile", type="string", length=255, nullable=true)
     */
    private $docxfile;

    /**
     * @var string
     *
     * @ORM\Column(name="epsfile", type="string", length=255, nullable=true)
     */
    private $epsfile;

    /**
     * @var string
     *
     * @ORM\Column(name="aifile", type="string", length=255, nullable=true)
     */
    private $aifile;

    /**
     * @var string
     *
     * @ORM\Column(name="video", type="string", length=255, nullable=true)
     */
    private $video;

    /**
     * @var string
     *
     * @ORM\Column(name="url", type="string", length=255, nullable=true)
     */
    private $url;

    /**
     * @var int
     *
     * @ORM\Column(name="position", type="integer")
     */
    private $position;
   

    /**
     * @ORM\Column(name="created_at", type="datetime")
     */
    protected $createdAt;

    /**
     * @ORM\Column(name="updated_at", type="datetime")
     */
    protected $updatedAt;

  
    /**
     * @param mixed $updatedAt
     * @return self
     */
    public function setUpdatedAt($updatedAt)
    {
        $this->updatedAt = $updatedAt;

        return $this;
    }

    /**
     * @ORM\PrePersist
     * @ORM\PreUpdate
     */
    public function updatedTimestamps()
    {
        $dateTimeNow = new DateTime('now');
        $this->setUpdatedAt($dateTimeNow);
        if ($this->getCreatedAt() === null) {
            $this->setCreatedAt($dateTimeNow);
        }
    }

    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->createdAt;
    }

    public function setCreatedAt(\DateTimeInterface $createdAt): self
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    public function getUpdatedAt(): ?\DateTimeInterface
    {
        return $this->updatedAt;
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getPicture(): ?string
    {
        return $this->picture;
    }

    public function setPicture(?string $picture): self
    {
        $this->picture = $picture;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getVersion(): ?string
    {
        return $this->version;
    }

    public function setVersion(string $version): self
    {
        $this->version = $version;

        return $this;
    }

    public function getResourcecategory(): ?ResourceCategory
    {
        return $this->resourcecategory;
    }

    public function setResourcecategory(?ResourceCategory $resourcecategory): self
    {
        $this->resourcecategory = $resourcecategory;

        return $this;
    }

    public function getPdffile(): ?string
    {
        return $this->pdffile;
    }

    public function setPdffile(?string $pdffile): self
    {
        $this->pdffile = $pdffile;

        return $this;
    }

    public function getPngfile(): ?string
    {
        return $this->pngfile;
    }

    public function setPngfile(?string $pngfile): self
    {
        $this->pngfile = $pngfile;

        return $this;
    }

    public function getPptfile(): ?string
    {
        return $this->pptfile;
    }

    public function setPptfile(?string $pptfile): self
    {
        $this->pptfile = $pptfile;

        return $this;
    }

    public function getVideo(): ?string
    {
        return $this->video;
    }

    public function setVideo(?string $video): self
    {
        $this->video = $video;

        return $this;
    }

    public function getUrl(): ?string
    {
        return $this->url;
    }

    public function setUrl(?string $url): self
    {
        $this->url = $url;

        return $this;
    }

    public function getZipfile(): ?string
    {
        return $this->zipfile;
    }

    public function setZipfile(?string $zipfile): self
    {
        $this->zipfile = $zipfile;

        return $this;
    }

    public function getVideofile(): ?string
    {
        return $this->videofile;
    }

    public function setVideofile(?string $videofile): self
    {
        $this->videofile = $videofile;

        return $this;
    }

    public function getDocxfile(): ?string
    {
        return $this->docxfile;
    }

    public function setDocxfile(?string $docxfile): self
    {
        $this->docxfile = $docxfile;

        return $this;
    }

    public function getEpsfile(): ?string
    {
        return $this->epsfile;
    }

    public function setEpsfile(?string $epsfile): self
    {
        $this->epsfile = $epsfile;

        return $this;
    }

    public function getAifile(): ?string
    {
        return $this->aifile;
    }

    public function setAifile(?string $aifile): self
    {
        $this->aifile = $aifile;

        return $this;
    }

    public function getPosition(): ?int
    {
        return $this->position;
    }

    public function setPosition(int $position): self
    {
        $this->position = $position;

        return $this;
    }


   
}
