<?php

namespace App\Repository;

use App\Entity\Category;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;

/**
 * @method Category|null find($id, $lockMode = null, $lockVersion = null)
 * @method Category|null findOneBy(array $criteria, array $orderBy = null)
 * @method Category[]    findAll()
 * @method Category[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class CategoryRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Category::class);
    }

    /**
    * @param string $role
    *
    * @return array
    */
    public function getAvailableCategories($user_role, $language)
    {
       $qb = $this->_em->createQueryBuilder();
       $qb->select('c')
           ->from('App:Category', 'c')
           ->where('c.roles like :role1')
           ->andWhere('c.language = :language')
           ->orderBy('c.position', 'ASC')
           ->setParameters(array(
            'role1'     => '%"'.$user_role.'"%',
            'language'    => $language,
           ));

       return $qb->getQuery()->getResult();
    }
}
