<?php

namespace App\Repository;


use Doctrine\ORM\EntityRepository;

class CertificateRepository extends EntityRepository
{

    /**
    * @param string $role
    *
    * @return array
    */
    public function graduatesTotalNumbers($program)
    {
       $qb = $this->_em->createQueryBuilder();
       $qb->select('SUM(c.number) AS total')
           ->from('App:Certificate', 'c')
           ->where('c.program = :program')
           ->setParameters(array(
            'program'      => $program,
          ))
           ->groupBy('c.program');

       return $qb->getQuery()->getSingleScalarResult();
    }

    /**
    * @param string $role
    *
    * @return array
    */
    public function graduatesByProgramCountryLanguageInitialValues($program, $country, $language)
    {
       $qb = $this->_em->createQueryBuilder();

       if($country != "ALL" && $language == "ALL"){
            $qb->select('SUM(c.initial) AS total')
                ->from('App:Certificate', 'c')
                ->where('c.program = :program')
                ->andWhere('c.country = :country')
                ->setParameters(array(
                'program'      => $program,
                'country'      => $country,
                ))
            ->groupBy('c.program');

       }
       else if($country == "ALL" && $language != "ALL"){
            $qb->select('SUM(c.initial) AS total')
                ->from('App:Certificate', 'c') 
                ->where('c.program = :program')
                ->andWhere('c.language = :language')
                ->setParameters(array(
                'program'      => $program,
                'language'      => $language,
                ))
            ->groupBy('c.program');

       }
       else if($country != "ALL" && $language != "ALL"){
            $qb->select('SUM(c.initial) AS total')
                ->from('App:Certificate', 'c')
                ->where('c.program = :program')
                ->andWhere('c.country = :country')
                ->andWhere('c.language = :language')
                ->setParameters(array(
                'program'      => $program,
                'country'      => $country,
                'language'      => $language,
                ))
            ->groupBy('c.program');

       }     

       try {
            return $qb->getQuery()->getSingleScalarResult();
       } catch (\Doctrine\ORM\NoResultException $exception) {
            return 0;
       }
    }

    

    /**
    * @param string $role
    *
    * @return array
    */
    public function countriesTotal()
    {
       $qb = $this->_em->createQueryBuilder();
       $qb->select('c')
           ->from('App:Certificate', 'c')
           ->where('c.program = :program')
           ->setParameters(array(
            'program'      => "MBS",
          ));

       return count($qb->getQuery()->getResult());
    }
    

}