<?php

namespace App\Repository;


use Doctrine\ORM\EntityRepository;

class GrantRepository extends EntityRepository
{

    /**
    * @param string $role
    *
    * @return array
    */
    public function grantByDate($state, $init_date)
    {
        $query = $this->getEntityManager()
            ->createQuery( 
            'SELECT g FROM App:Grant g
             WHERE g.state = :state
             AND g.deadlineDate < :init_date'
        )->setParameters(array(
            'init_date'   => $init_date,
            'state'          => $state,
        ));

        try {
            return $query->getResult();
        } catch (\Doctrine\ORM\NoResultException $exception) {
            return null;
        }
    }

}
