<?php

namespace App\Repository;

use App\Entity\PilotGroup;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;

/**
 * @method PilotGroup|null find($id, $lockMode = null, $lockVersion = null)
 * @method PilotGroup|null findOneBy(array $criteria, array $orderBy = null)
 * @method PilotGroup[]    findAll()
 * @method PilotGroup[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class PilotGroupRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, PilotGroup::class);
    }

    /**
    * @param string $pilotambassador
    *
    * @return array
    */
    public function deletePilotGroups($ambassador)
    {
       $qb = $this->_em->createQueryBuilder();
       $qb->delete('App:PilotGroup', 'g')
           ->where('g.ambassador = :ga')
           ->setParameters(array(
             'ga'     => $ambassador,
           ));

       return $qb->getQuery()->getResult();
    }
}
