<?php

namespace App\Repository;

use App\Entity\Principle;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;

/**
 * @method Principle|null find($id, $lockMode = null, $lockVersion = null)
 * @method Principle|null findOneBy(array $criteria, array $orderBy = null)
 * @method Principle[]    findAll()
 * @method Principle[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class PrincipleRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Principle::class);
    }

   /**
    * @param string $role
    *
    * @return array
    */
    public function principleConsecutive($course_id)
    {

       $qb = $this->_em->createQueryBuilder();
       $qb->select('p')
           ->from('App:Principle', 'p')   
           ->join('p.unit', 'u')     
           ->where('u.course = :course')
           ->orderBy('p.position' , 'DESC') 
           ->setMaxResults(1)        
           ->setParameters(array(           
             'course'    => $course_id,
           ));

           //$$qb->getQuery()->getResult();
           $result_1 = $qb->getQuery()->getOneOrNullResult();

       if(is_null($result_1)){
           
            
            return 0;
       }
       else{
            return $result_1->getPosition();
       }       
    }

    /**
    * @param string $course_id
    *
    * @return array
    */
    public function principlesTotal($course_id){
      
        $qb = $this->_em->createQueryBuilder();
        $qb->select('count(p.id)')
           ->from('App:Principle', 'p')   
           ->join('p.unit', 'u')     
           ->where('u.course = :course')
           ->andWhere('p.state = :state')
           ->setParameters(array(
             'course'         => $course_id,
             'state'          => 'state.published'
            ))
            ;
 
        return $qb->getQuery()->getSingleScalarResult();
    }
    

}
