<?php

namespace App\Repository;

use App\Entity\Resource;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;

/**
 * @method Resource|null find($id, $lockMode = null, $lockVersion = null)
 * @method Resource|null findOneBy(array $criteria, array $orderBy = null)
 * @method Resource[]    findAll()
 * @method Resource[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class ResourceRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Resource::class);
    }

    public function resourceByCategoryLanguage($language, $category, $subcategory)
    {
        $qb = $this->_em->createQueryBuilder();

        if($language != "ALL" && $category != "ALL" && $subcategory != "ALL"){

            $qb->select('r') 
            ->from('App:Resource', 'r')
            ->join('r.resourcecategory', 'rc')
            ->join('rc.category', 'c')
            ->where('c.language = :language')
            ->andWhere('rc.category = :category')
            ->andWhere('r.resourcecategory = :subcategory')
            ->orderBy('r.position', 'ASC')
            ->setParameters(array(
            'language'          => $language,
            'category'          => $category,
            'subcategory'       => $subcategory,
            ));

        }
        else if($language != "ALL" && $category != "ALL" && $subcategory == "ALL"){

            $qb->select('r') 
            ->from('App:Resource', 'r')
            ->join('r.resourcecategory', 'rc')
            ->join('rc.category', 'c')
            ->where('c.language = :language')
            ->andWhere('rc.category = :category')
            ->orderBy('r.position', 'ASC')
            ->setParameters(array(
            'language'          => $language,
            'category'          => $category,
            ));
        }
        else if($language != "ALL" && $category == "ALL" && $subcategory == "ALL"){
            $qb->select('r') 
            ->from('App:Resource', 'r')
            ->join('r.resourcecategory', 'rc')
            ->join('rc.category', 'c')
            ->where('c.language = :language')
            ->orderBy('r.position', 'ASC')
            ->setParameters(array(
            'language'          => $language,
            ));
        }
        else if($language == "ALL" && $category == "ALL" && $subcategory == "ALL"){

            $qb->select('r') 
            ->from('App:Resource', 'r')
            ->orderBy('r.position', 'ASC')
            ;
        }
        else{

            $qb->select('r') 
            ->from('App:Resource', 'r')
            ->orderBy('r.position', 'ASC')
            ;
        }
        
        return $result =  $qb->getQuery()->getResult();
            
    }

   
}
