<?php

namespace App\Repository;

use App\Entity\Section;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;

/**
 * @method Section|null find($id, $lockMode = null, $lockVersion = null)
 * @method Section|null findOneBy(array $criteria, array $orderBy = null)
 * @method Section[]    findAll()
 * @method Section[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class SectionRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Section::class);
    }

    /**
    * @param string $role
    *
    * @return array
    */
    public function getAvailableResources($user_role, $language)
    {
       $qb = $this->_em->createQueryBuilder();
       $qb->select('s')
           ->from('App:Section', 's')
           ->leftJoin('s.tutorials', 't')
           ->where('t.roles like :role1')
           ->andWhere('t.language = :language')
           ->setParameters(array(
            'role1'     => '%"'.$user_role.'"%',
            'language'    => $language,
           ));

       return $qb->getQuery()->getResult();
    }
}
