<?php

namespace App\Repository;

use App\Entity\Translation;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;

/**
 * @method Translation|null find($id, $lockMode = null, $lockVersion = null)
 * @method Translation|null findOneBy(array $criteria, array $orderBy = null)
 * @method Translation[]    findAll()
 * @method Translation[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class TranslationRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Translation::class);
    }

    /**
    * @param string $role
    *
    * @return array
    */
    public function getLabels($pattern, $language)
    {
       $qb = $this->_em->createQueryBuilder();
       $qb->select('t')
           ->from('App:Translation', 't')
           ->where('t.label LIKE :pattern')
           ->andWhere('t.language = :language')
           ->setParameters(array(
             'pattern'     => '%'.$pattern.'%',
             'language'    => $language
           ));

       return $qb->getQuery()->getResult();
    }
}
