<?php

namespace App\Repository;

use App\Entity\Tutorial;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;

/**
 * @method Tutorial|null find($id, $lockMode = null, $lockVersion = null)
 * @method Tutorial|null findOneBy(array $criteria, array $orderBy = null)
 * @method Tutorial[]    findAll()
 * @method Tutorial[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class TutorialRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Tutorial::class);
    }

     /**
    * @param string $role
    *
    * @return array
    */
    public function tutorialsByKeyword($user_role, $language, $keyword, $device)
    {
       $qb = $this->_em->createQueryBuilder();
       $qb->select('t')
           ->from('App:Tutorial', 't')
           ->where('t.roles LIKE :role1')
           ->andWhere('t.language = :language')
           ->andWhere('t.device = :device')
           ->andWhere('CONCAT(t.name, t.description, t.content ) LIKE :keyword') 
           ->setParameters(array(
            'role1'     => '%"'.$user_role.'"%',
            'keyword'    => '%'.$keyword.'%',
            'language'    => $language,
            'device'    => $device,
           ));

       return $qb->getQuery()->getResult();
    }

    
}