<?php

namespace App\Repository;


use Doctrine\ORM\EntityRepository;

class UnitRepository extends EntityRepository
{

    /**
    * @param string $role
    *
    * @return array
    */
    public function unitConsecutive($course_id)
    {

         
       $qb = $this->_em->createQueryBuilder();
       $qb->select('u')
           ->from('App:Unit', 'u')        
           ->where('u.course = :course')         
           ->setParameters(array(           
             'course'    => $course_id,
           ));

           $result_1 =  $qb->getQuery()->getResult();

       if($result_1){
            $query = $this->_em->createQueryBuilder();
            $query->select('u, MAX(u.position) AS maxPosition')
            ->from('App:Unit', 'u')        
            ->where('u.course = :course')
            ->groupBy('u.id')         
            ->setParameters(array(           
            'course'    => $course_id,
            ));

            $result =  $query->getQuery()->getScalarResult();
            return $result[0]['maxPosition'];

       }
       else{
           return 0;
       }

       
    }

     /**
    * @param string $role
    *
    * @return array
    */
    public function unitsByCourse($course_id)
    {
      
       $query = $this->getEntityManager()
          ->createQuery(
          'SELECT u FROM App:Unit u
           JOIN App:Principle p
           WITH p.unit = u.id
           WHERE u.course = :course_id
           ORDER BY u.position ASC'
        )->setParameters(array(
            'course_id' => $course_id,
        ));

      try {
          return $query->getResult();
      } catch (\Doctrine\ORM\NoResultException $exception) {
          return null;
      }
    }
    

}